/////////////////////////////////////////////////////////////////////////////////////////////////////////
// WaterGameDemo
// MBlueFish.h
// 
// Code : Anael Seghezzi
/////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef _M_BLUE_FISH_H
#define _M_BLUE_FISH_H


class MBlueFish : public MBehavior
{
public:

	// constructors / destructors
	MBlueFish(MObject3d * parentObject);
	MBlueFish(MBlueFish & behavior, MObject3d * parentObject);
	virtual ~MBlueFish(void);

private:

	float m_speed;

	float m_currentSpeed;
	float m_currentRotSpeed;
	MVector3 m_target;

private:

	void init(void);

public:

	// destroy
	void destroy(void);

	// get new
	static MBehavior * getNew(MObject3d * parentObject);

	// get copy
	MBehavior * getCopy(MObject3d * parentObject);

	// name
	static const char * getStaticName(void){ return "BlueFish"; }
	const char * getName(void){ return getStaticName(); }

	// events
	void update(void);
	void runEvent(int param){}

	// variables
	unsigned int getVariablesNumber(void);
	MVariable getVariable(unsigned int id);

	// cutom variables
	inline float getSpeed(void){ return m_speed; }
};

#endif