/////////////////////////////////////////////////////////////////////////////////////////////////////////
// WaterGameDemo
// MWaterGame.cpp
// 
// Code : Anael Seghezzi
/////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "MWaterGame.h"


MWaterGame::MWaterGame(void):
MGame(),
m_blueFishsNumber(0),
m_redFishsNumber(0)
{}

MWaterGame::~MWaterGame(void)
{
}

void MWaterGame::onBeginScene(void)
{
	MEngine * engine = MEngine::getInstance();

	// get level
	MLevel * level = MEngine::getInstance()->getLevel();
	if(! level)
		return;

	// get current scene
	MScene * scene = level->getCurrentScene();
	if(! scene)
		return;


	// prepare game
	{
		m_blueFishsNumber = 0;
		m_redFishsNumber = 0;
		
		// behaviors
		unsigned int i;
		unsigned int oSize = scene->getObjectsNumber();
		for(i=0; i<oSize; i++)
		{
			MObject3d * object = scene->getObjectByIndex(i);

			unsigned int b;
			unsigned int bSize = object->getBehaviorsNumber();
			for(b=0; b<bSize; b++)
			{
				MBehavior * behavior = object->getBehavior(b);

				if((strcmp(behavior->getName(), MBlueFish::getStaticName()) == 0) && (m_blueFishsNumber < MAX_BLUE_FISHS))
				{
					m_blueFishs[m_blueFishsNumber] = (MBlueFish *)behavior;
					m_blueFishsNumber++;
				}

				if((strcmp(behavior->getName(), MRedFish::getStaticName()) == 0) && (m_redFishsNumber < MAX_RED_FISHS))
				{
					m_redFishs[m_redFishsNumber] = (MRedFish *)behavior;
					m_redFishsNumber++;
				}
			}
		}
	}

	// update objects
	scene->updateObjectsMatrices();

	// start sound
	scene->playLoopSounds();

	// prepare physics
	scene->preparePhysics();

	// run script
	engine->getScriptContext()->runScript(scene->getScriptFilename());
}

void MWaterGame::onEndScene(void)
{
	m_blueFishsNumber = 0;
	m_redFishsNumber = 0;

	MEngine * engine = MEngine::getInstance();
	engine->getPhysicsContext()->clear();

	// get level
	MLevel * level = MEngine::getInstance()->getLevel();
	if(! level)
		return;

	// get current scene
	MScene * scene = level->getCurrentScene();
	if(! scene)
		return;

	scene->stopAllSounds();
}