/////////////////////////////////////////////////////////////////////////////////////////////////////////
// WaterGameDemo
// MWaterGame.h
// 
// Code : Anael Seghezzi
/////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef _M_WATER_GAME_H
#define _M_WATER_GAME_H

#include <MEngine.h>
#include "MBlueFish.h"
#include "MRedFish.h"

#define MAX_RED_FISHS 256
#define MAX_BLUE_FISHS 1024


class MWaterGame : public MGame
{
private:

	// blue fishs
	unsigned int m_blueFishsNumber;
	MBlueFish * m_blueFishs[MAX_BLUE_FISHS];

	// red fishs
	unsigned int m_redFishsNumber;
	MRedFish * m_redFishs[MAX_RED_FISHS];

public:

	// constructors / destructors
	MWaterGame(void);
	~MWaterGame(void);

public:

	// get blue fishs
	inline unsigned int getBlueFishsNumber(void){ return m_blueFishsNumber; }
	inline MBlueFish * getBlueFish(unsigned int id){ return m_blueFishs[id]; }

	// get red fishs
	inline unsigned int getRedFishsNumber(void){ return m_redFishsNumber; }
	inline MRedFish * getRedFish(unsigned int id){ return m_redFishs[id]; }

	// events
	void onBeginScene(void);
	void onEndScene(void);
};

#endif